unit EditColor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TEditColor = class(TCustomEdit)
  private
    FCorEntrada : TColor ;
    FCorSaida   : TColor ;
    procedure SetCorEntra(Value : TColor);
    procedure SetCorSai(Value : TColor);

  protected
    procedure DoEnter; override;
    procedure DoExit; override;

  public
    constructor Create(AOwner:TComponent);override;

  published
    property AutoSelect;
    property AutoSize;
    property BorderStyle;
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property MaxLength;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;

    property CorEntrada : TColor read FCorEntrada write SetCorEntra ;
    property CorSaida   : TColor read FCorSaida   write SetCorSai ;

  end;

procedure Register;

implementation

constructor TEditColor.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 90;
  CorEntrada := clYellow ;
  CorSaida   := clWindow ;
end;

procedure TEditColor.SetCorEntra(Value : TColor);
begin
  if FCorEntrada <> Value then begin
    FCorEntrada := Value;
    Invalidate;
  end;
end;

procedure TEditColor.SetCorSai(Value : TColor);
begin
  if FCorSaida <> Value then begin
    FCorSaida := Value;
    Invalidate;
  end;
end;

procedure TEditColor.DoEnter ;
begin
     Color := FCorEntrada ;
     inherited DoEnter ;
end;

procedure TEditColor.DoExit ;
begin
     Color := FCorSaida ;
     inherited DoExit;
end;

procedure Register;
begin
  RegisterComponents('Data7', [TEditColor]);
end;

end.
